﻿using Accordion.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace Accordion.Controls
{
    public class InspectionItemTemplateSelector : DataTemplateSelector
    {
        public DataTemplate StringDataTemplate { get; set; }

        public DataTemplate LongStringDataTemplate { get; set; }

        public DataTemplate IntegerDataTemplate { get; set; }
        public DataTemplate DecimalDataTemplate { get; set; }
        public DataTemplate DateTimeDataTemplate { get; set; }
        public DataTemplate ComboBoxDataTemplate { get; set; }
        public DataTemplate BooleanDataTemplate { get; set; }
        public DataTemplate RadioButtonDataTemplate { get; set; }
        public DataTemplate DocLinkDataTemplate { get; set; }
        public DataTemplate MultiSelectDataTemplate { get; set; }
        public DataTemplate ResetDocLinkDataTemplate { get; set; }
        public DataTemplate PastDateDataTemplate { get; set; }

        protected override DataTemplate SelectTemplateCore(object item, DependencyObject container)
        {
            if (item == null) return null;

            string inspectionItemDataType = ((InspectionItem)item).DataType;

            switch (inspectionItemDataType)
            {
                case "string":
                    return StringDataTemplate;
                case "longstring":
                    return LongStringDataTemplate;
                case "integer":
                    return IntegerDataTemplate;
                case "decimal":
                    return DecimalDataTemplate;
                case "date":
                    return DateTimeDataTemplate;
                case "pastDate":
                    return PastDateDataTemplate;
                case "dropDown":
                    return ComboBoxDataTemplate;
                case "radioButtons":
                    return RadioButtonDataTemplate;
                case "boolean":
                    return BooleanDataTemplate;
                case "docLink":
                    return DocLinkDataTemplate;
                case "resetDocLink":
                    return ResetDocLinkDataTemplate;
                case "multiSelect":
                    return MultiSelectDataTemplate;
                default:
                    return StringDataTemplate;
            }
        }
    }

}
