﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Data.Json;

namespace Accordion.Model
{
    public class AvailableOptionCollection
    {
        private const string idKey = "id";
        private const string optionsKey = "options";

        private string id;
        private ObservableCollection<AvailableOption> availableOptions;

        public AvailableOptionCollection()
        {
            id = string.Empty;
            availableOptions = new ObservableCollection<AvailableOption>();
        }

        public AvailableOptionCollection(JsonObject jsonObject) : this()
        {
            if (jsonObject != null)
            {
                Id = jsonObject.GetNamedString(idKey, "");
                foreach (IJsonValue jsonValue in jsonObject.GetNamedArray(optionsKey, new JsonArray()))
                {
                    if (jsonValue.ValueType == JsonValueType.Object)
                    {
                        availableOptions.Add(new AvailableOption(jsonValue.GetObject()));
                    }
                }
            }
        }

        public string Id
        {
            get
            {
                return id;
            }
            set
            {
                if (value == null)
                {
                    throw new ArgumentNullException("value");
                }
                id = value;
            }
        }

        public ObservableCollection<AvailableOption> AvailableOptions
        {
            get
            {
                return availableOptions;
            }
        }

   

    }

}
